#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <stdio.h>
#include "latecki.h"

#define X 0
#define Y 1

#define PI 3.141592653

int Convert_mapto_double(double **tab,pixeldepth_t *pixels)
{
   int i;
//   printf("%p\n",pixels);
   for(i=0 ; i< TRANS_X; i++)
   {
       tab[i][0] = i;
       tab[i][1] = pixels->tabcorr[i];
   }
   return 0;
}

int Polygone(int nb_iteration,double **Tab_Input,int nb_points,double **Tab_Output,int *nb_pt_poly1)
{
	double o_l1,o_l2;
	double l1,l2,teta,distance=0,**W;
	int u,v,w,j,k,l;
	double Min = 99999;
	int indice=-1,nb=-1,i,iteration;
	// Allocation
	W = (double**)malloc(sizeof(double*)*nb_points);
	for(i=0 ; i<nb_points ; i++)
	{
		W[i]=(double*)malloc(sizeof(double)*2);
		for(j=0 ; j<2 ; j++)
			W[i][j] = 0;
	}
	for(iteration=0 ; iteration<nb_iteration ; iteration++)
	{
		distance = 0;
		// Détermination de la distance totale du polygone actif
		for(i=0 ; i<nb_points-1 ; i++)
		{
			j=i+1;
			distance += sqrt( (i-j)*(i-j) + 
				(Tab_Input[i][Y] - Tab_Input[j][Y])*(Tab_Input[i][Y] - Tab_Input[j][Y]));
		}
		for(i=1 ; i<nb_points-1 ; i++)
		{
			l1 = 0;
			l2 = 0;
			// Détermination du point central
			if(W[i][1] == 1)
				continue;
			else
				v=i;
			// Détermination du voisin de gauche
			for(u = (i-1) ; ;u--)
			{
				if(u < 0)
					u = nb_points-2;
				l1 += sqrt( (u-(u+1))*(u-(u+1)) + 
					(Tab_Input[u][Y] - Tab_Input[u+1][Y])*(Tab_Input[u][Y] - Tab_Input[u+1][Y]));
				if(W[u][1] == 0)
					 break;
			}
			// Détermination du voisin de droite
			// @@@ for(w = (i+1) ;; w++)
			for(w = (i+4) ;; w++)
			{
				if(w >= nb_points-1)
					w = 0;
				l2 += sqrt( (w-(w+1))*(w-(w+1)) + 
					(Tab_Input[w][Y] - Tab_Input[w+1][Y])*(Tab_Input[w][Y] - Tab_Input[w+1][Y]));

				if(W[w][1] == 0)
					break;
			}
			// Calcul des distances
			o_l1 = sqrt( (u-v)*(u-v) +
				(Tab_Input[u][Y] - Tab_Input[v][Y])*(Tab_Input[u][Y] - Tab_Input[v][Y])  );
			o_l2 = sqrt( (v-w)*(v-w) +
				(Tab_Input[v][Y] - Tab_Input[w][Y])*(Tab_Input[v][Y] - Tab_Input[w][Y] ));
			// Normalisation des distances
			l1 /= distance;
			l2 /= distance;
			// Produit scalaire
//			teta = (u*v) + Tab_Input[u][Y]*Tab_Input[v][Y];
			teta = (v-u)*(w-v) + (Tab_Input[v][Y]-Tab_Input[u][Y])*(Tab_Input[w][Y]-Tab_Input[v][Y]);
			// Normalisation du produit scalaire
//			teta /= sqrt( u*u + Tab_Input[u][Y]*Tab_Input[u][Y] ) *
//					sqrt( v*v + Tab_Input[v][Y]*Tab_Input[v][Y] );
			teta /= sqrt( (v-u)*(v-u) + (Tab_Input[v][Y]-Tab_Input[u][Y])*(Tab_Input[v][Y]-Tab_Input[u][Y]) ) *
					sqrt( (w-v)*(w-v) + (Tab_Input[w][Y]-Tab_Input[v][Y])*(Tab_Input[w][Y]-Tab_Input[v][Y]) );
//			printf("%g\n",teta);
			// Détermination de l'angle
//			if (teta<0)
//				teta *= -1;
//				teta += 2*PI;
			teta = acos(teta);
//			printf("%g\n",teta);
//			if(teta <= PI /2 + 0.2 || teta >= PI/2 - 0.2)
			//if(teta <= PI/2-0.3)			
//			printf("%g ",teta);
			//if(teta <= 3*PI/4)			
			//if(teta <= 0.01)			

			//if(teta <= 0.01)			
			//   teta = 0;
			
//			teta = PI - teta;
//			W[i][0] = (teta*l1*l2) / (l1 + l2);
			W[i][0] = teta;
		}	
		// Recherche des Max
		Min = -DBL_MAX;
		for(i=0 ; i<nb_points ; i++)
		{
			//if((Min > W[i][0]) && (W[i][1] == 0))
			if((Min < W[i][0]) && (W[i][1] == 0))
			{
				indice = i;
				Min = W[i][0];
			}
		}
		// Suppression DU max
		for(i=0,nb=0 ; i<nb_points ; i++)
		{

#if 0		        /* Marquage du point */
		        if((i == indice)&& (W[i][1] == 0))
			{
				W[i][1] = 1;
		//		printf("point supprimé : %g (%g %g)\n",W[i][0],Tab_Input[i][X],Tab_Input[i][Y]);
			}
			if(W[i][1] == 0)
			{
				// ne sert à rien ??
			 	Tab_Output[i][Y] = Tab_Input[i][Y];
				nb++;
			}
#else
			/*Marquage d'un point*/
		        if((W[i][0] > 3*PI/4)&& (W[i][1] == 0))
			{
			    W[i][1] = 1;
			}
			
#endif
		}
	}
//	printf("Nombre d'iteration     : %d\n",nb_iteration);
//	printf("Nombre actif du signal : %d (pour %d)\n",nb,nb_points);
	(*nb_pt_poly1) = nb;
	for(i=0,u=0 ; i<nb_points ; i++)
	{
#if 1
	        /* Point marqué */
		if(W[i][1] == 1)
		{
                        int acc = 0;
                        int div = 0;
#if 1
			/*Valeur du point avec */
		        Tab_Output[u][X] = i;
			if(i>0)
			{
			   acc += Tab_Input[i-1][Y];
			   div++;
			}
			if(i<nb_points-1)
			{
			   acc += Tab_Input[i+1][Y];
			   div++;
			}
			Tab_Output[u][Y] = acc/div;
			//Tab_Output[u][Y] = (Tab_Input[i-1][Y]+Tab_Input[i+1][Y])/2;
#else 
			for(k=i ;; k++)
			{
 			    if(k >= nb_points-1)
				break;
			    if(W[k][1] != 1)
			    {
			      div++;
			      break;
			    }
			}
			acc += Tab_Input[k][Y];
			for(k=i ;; k--)
			{
 			    if(k < 1 )
			     break;
			    if(W[k][1] != 1)
			    {
			       div++;
			       break;
			    }
			}
			acc += Tab_Input[k][Y];
			

			
			//Tab_Output[u][Y] = -1;
			Tab_Output[u][X] = i;
			Tab_Output[u][Y] = acc/div;
		//	Tab_Output[u][Y] = -1;
#endif
		}
		else
		{
			Tab_Output[u][X] = i;
			Tab_Output[u][Y] = Tab_Input[i][Y];
		}
		u++;
#else
	        /* Point marqué */
		if(W[i][1] == 1)
			continue;
		Tab_Output[u][X] = i;
		Tab_Output[u][Y] = Tab_Input[i][Y];
		u++;
#endif
	}
    for(i=0 ; i<nb_points ; i++)
      free(W[i]);
    free(W);
    return 0;
}

